precision highp float;

attribute vec3 position;
attribute vec3 normal;
attribute vec2 uv;
varying vec2 texcoordVarying;
varying vec4 diffuseVarying;

uniform mat4 mvp;

const vec3 lightDirection01 = vec3( 0, 0, 1 );
const vec3 lightDirection02 = vec3( 0.5773502691896258, 0.5773502691895258, 0.5773502691896258 );
const vec3 lightDirection03 = vec3( 0, -1, 0 );


void main()
{

    float underShading = min( 1.0, smoothstep( 0.0, 4.0, position.z ) + 0.8 );
    
    texcoordVarying = uv;	
    float light01Dot = ( dot( lightDirection01, normal.xyz ) + 1.0 ) * 0.5;
    float light02Dot = ( dot( lightDirection02, normal.xyz ) + 1.0 ) * 0.5;
    float light03Dot = ( dot( lightDirection03, normal.xyz ) + 1.0 ) * 0.5;
    
    float color = smoothstep( 0.0, 1.0, light01Dot * 0.85 + light02Dot * 0.1 + light03Dot * 0.05 - 1.0  );
    diffuseVarying = vec4( color * underShading, color * underShading, color * underShading, 1.0 );
    
    gl_Position = mvp * vec4( position.x, position.y, position.z, 1.0 );
}